Imports System.Data
Imports System.Data.SqlClient
Imports System.Collections.Generic

Public Class Customer
    Private strID As String
    Private strCompany As String
    Private strContact As String
    Private strCountry As String

    Public Property CustomerID() As String
        Get
            Return strID
        End Get
        Set(ByVal value As String)
            strID = value
        End Set
    End Property

    Public Property CompanyName() As String
        Get
            Return strCompany
        End Get
        Set(ByVal value As String)
            strCompany = value
        End Set
    End Property

    Public Property ContactName() As String
        Get
            Return strContact
        End Get
        Set(ByVal value As String)
            strContact = value
        End Set
    End Property

    Public Property Country() As String
        Get
            Return strCountry
        End Get
        Set(ByVal value As String)
            strCountry = value
        End Set
    End Property

    Public Shared Function Insert(ByVal c As Customer) As Integer
        Dim sql As String
        sql = "insert into customers(customerid,companyname,contactname,country) values(@custid,@company,@contact,@country)"
        Dim params(3) As SqlParameter
        params(0) = New SqlParameter("@custid", c.CustomerID)
        params(1) = New SqlParameter("@company", c.CompanyName)
        params(2) = New SqlParameter("@contact", c.ContactName)
        params(3) = New SqlParameter("@country", c.Country)
        Return SqlHelper.ExecuteNonQuery(sql, params)
    End Function

    Public Shared Function Update(ByVal c As Customer) As Integer
        Dim sql As String
        sql = "update customers set companyname=@company,contactname=@contact,country=@country where customerid=@custid"
        Dim params(3) As SqlParameter
        params(0) = New SqlParameter("@company", c.CompanyName)
        params(1) = New SqlParameter("@contact", c.ContactName)
        params(2) = New SqlParameter("@country", c.Country)
        params(3) = New SqlParameter("@custid", c.CustomerID)
        Return SqlHelper.ExecuteNonQuery(sql, params)
    End Function

    Public Shared Function Delete(ByVal c As Customer) As Integer
        Dim sql As String
        sql = "delete from customers where customerid=@custid"
        Dim params(0) As SqlParameter
        params(0) = New SqlParameter("@custid", c.CustomerID)
        Return SqlHelper.ExecuteNonQuery(sql, params)
    End Function

    Public Shared Function SelectAll() As List(Of Customer)
        Dim ds As DataSet = SqlHelper.ExecuteDataSet("select customerid,companyname,contactname,country from customers")
        Dim arr As New List(Of Customer)
        For Each row As DataRow In ds.Tables(0).Rows
            Dim c As New Customer
            c.CustomerID = row("customerid")
            c.CompanyName = row("companyname")
            c.ContactName = row("contactname")
            c.Country = row("country")
            arr.Add(c)
        Next
        Return arr
    End Function

    Public Shared Function SelectSingle(ByVal custid As String) As Customer
        Dim params(0) As SqlParameter
        params(0) = New SqlParameter("@custid", custid)
        Dim ds As DataSet = SqlHelper.ExecuteDataSet("select customerid,companyname,contactname,country from customers where customerid=@custid", params)
        Dim row As DataRow = ds.Tables(0).Rows(0)
        Dim c As New Customer
        c.CustomerID = row("customerid")
        c.CompanyName = row("companyname")
        c.ContactName = row("contactname")
        c.Country = row("country")
        Return c
    End Function
End Class
